#include <stdio.h>
#include <malloc.h>
//#include <conio.h>
//#include <dos.h>

typedef unsigned short BOOL;
typedef unsigned char BYTE;
typedef signed char SBYTE;
typedef unsigned char UBYTE;
typedef unsigned short WORD;
typedef signed short SWORD;
typedef unsigned short UWORD;
typedef unsigned long DWORD;
typedef signed long SDWORD;
typedef unsigned long UDWORD;
typedef unsigned char UCHAR;
typedef signed char SCHAR;
typedef unsigned short USHORT;
typedef signed short SSHORT;
typedef unsigned int UINT;
typedef signed int SINT;
typedef unsigned long ULONG;
typedef signed long SLONG;
typedef unsigned long LONG;

#define NUM_COLORS 256

typedef struct tagBITMAP{
  WORD width;
  WORD height;
  BYTE *data;
} BITMAP;

typedef struct tagMESSAGE{char data[105];} MESSAGE;

void fskip(FILE *fp, int num_bytes){
  int i;for (i=0; i<num_bytes; i++) fgetc(fp);}

void load_bmp(char *file,BITMAP *b)
{
  FILE *fp; long index; WORD num_colors; int x;
  WORD biBitCount,biCompression;
  if ((fp = fopen(file,"rb")) == NULL) {
    printf("Error opening file %s.\n",file);
    exit(1);}
  if (fgetc(fp)!='B' || fgetc(fp)!='M') {
    fclose(fp); printf("Not a bitmap!\n"); exit(1);}
  fskip(fp,16);
  fread(&b->width,sizeof(WORD),1,fp);
  fskip(fp,2);
  fread(&b->height,sizeof(WORD),1,fp);
  fskip(fp,4);
  fread(&biBitCount,sizeof(WORD),1,fp);
  fread(&biCompression,sizeof(WORD),1,fp);
  fskip(fp,14);
  fread(&num_colors,sizeof(WORD),1,fp);
  fskip(fp,6);
  if (num_colors==0) num_colors=256;
  if(biBitCount!=8){
    fclose(fp);
    printf("This is not an 8-bit (256) color bitmap");
    exit(1);}
  if(biCompression!=0){
    fclose(fp);
    printf("RLE compression is not supported (yet?)");
    exit(1);}
  if ((b->data = (BYTE *) malloc((WORD)(b->width*b->height))) == NULL){
    fclose(fp);
    printf("Not enough memory",file);
    exit(1);}
  fskip(fp,num_colors*4);
  for(index=(b->height-1)*b->width;index>=0;index-=b->width)
    for(x=0;x<b->width;x++)
      b->data[(WORD)index+x]=(BYTE)fgetc(fp);
  fclose(fp);
}



unsigned char plane[38][3][8];

void doletter(char number,BITMAP *bmp)
{
  char i,j,w,done=0;
  unsigned char calc;
  char buffera[8][8]={0};
  char buffer[3][8][8]={0};
  unsigned char bufferf[8]={0};
  int offset=9*number;
  for(i=0;i<8;i++){
    for(j=0;j<8;j++){
      buffera[i][j]=bmp->data[(i+offset)*bmp->width+j];
    }
  }
  for(i=0;i<8;i++){
    for(j=0;j<8;j++){
      done=0;
      if(buffera[i][j]==0) {buffer[0][i][j]=1;buffer[1][i][j]=1;buffer[2][i][j]=0;done++;}
      if(buffera[i][j]==7) {buffer[0][i][j]=1;buffer[1][i][j]=0;buffer[2][i][j]=0;done++;}
      if(buffera[i][j]==8) {buffer[0][i][j]=0;buffer[1][i][j]=1;buffer[2][i][j]=0;done++;}
      if(buffera[i][j]==15){buffer[0][i][j]=0;buffer[1][i][j]=0;buffer[2][i][j]=0;done++;}
      if(!done) {buffer[0][i][j]=0;buffer[1][i][j]=0;buffer[2][i][j]=1;}
    }
  }
  for(w=0;w<3;w++){
    for(i=0;i<8;i++){
      calc=0;
      for(j=0;j<8;j++){
        calc+=buffer[w][i][j]<<(7-j);
      }
    bufferf[i]=calc;
    }
    for(i=0;i<8;i++) {plane[number][w][i]=bufferf[i];}
  }
}

#define dumpchar(p,l) plane[l][p][0],plane[l][p][1],plane[l][p][2],plane[l][p][3],plane[l][p][4],plane[l][p][5],plane[l][p][6],plane[l][p][7]
char ENTERCH[2]={13,10};
#define ENTER fwrite(ENTERCH,2,1,fp);



void exportdata(char outputfile[]){
{
  char buffer[80]={0};
	FILE *fp;
  char i;
		fp = fopen(outputfile, "wb");

    sprintf(buffer,"unsigned char sprcolon1[]={0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X};",dumpchar(0,26));
      fwrite(buffer,strlen(buffer), 1, fp);ENTER;
    sprintf(buffer,"unsigned char sprdash1[]={0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X};",dumpchar(0,27));
      fwrite(buffer,strlen(buffer), 1, fp);ENTER;ENTER;

    sprintf(buffer,"unsigned char sprcolon2[]={0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X};",dumpchar(1,26));
      fwrite(buffer,strlen(buffer), 1, fp);ENTER;
    sprintf(buffer,"unsigned char sprdash2[]={0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X};",dumpchar(1,27));
      fwrite(buffer,strlen(buffer), 1, fp);ENTER;ENTER;

    sprintf(buffer,"unsigned char sprcolonm[]={0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X};",dumpchar(2,26));
      fwrite(buffer,strlen(buffer), 1, fp);ENTER;
    sprintf(buffer,"unsigned char sprdashm[]={0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X};",dumpchar(2,27));
      fwrite(buffer,strlen(buffer), 1, fp);ENTER;ENTER;

    fwrite("unsigned char letter1[]={",25,1,fp); ENTER;
      for(i=0;i<26;i++) {
        sprintf(buffer,"0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X",dumpchar(0,i));
        fwrite(buffer,strlen(buffer),1,fp);
        if(i!=25) {fwrite(",",1,1,fp);ENTER;}}
    fwrite("};",2,1,fp);ENTER;ENTER; for(i=0;i<80;i++) buffer[i]=0;

    fwrite("unsigned char letter2[]={",25,1,fp); ENTER;
      for(i=0;i<26;i++) {
        sprintf(buffer,"0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X",dumpchar(1,i));
        fwrite(buffer,strlen(buffer),1,fp);
        if(i!=25) {fwrite(",",1,1,fp);ENTER;}}
    fwrite("};",2,1,fp); ENTER;ENTER;

    fwrite("unsigned char letterm[]={",25,1,fp); ENTER;
      for(i=0;i<26;i++) {
        sprintf(buffer,"0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X",dumpchar(2,i));
        fwrite(buffer,strlen(buffer),1,fp);
        if(i!=25) {fwrite(",",1,1,fp);ENTER;}}
    fwrite("};",2,1,fp); ENTER;ENTER;

    fwrite("unsigned char number1[]={",25,1,fp); ENTER;
      for(i=28;i<39;i++) {
        sprintf(buffer,"0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X",dumpchar(0,i));
        fwrite(buffer,strlen(buffer),1,fp);
        if(i!=38) {fwrite(",",1,1,fp);ENTER;}}
    fwrite("};",2,1,fp); ENTER;ENTER;

    fwrite("unsigned char number2[]={",25,1,fp); ENTER;
      for(i=28;i<39;i++) {
        sprintf(buffer,"0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X",dumpchar(1,i));
        fwrite(buffer,strlen(buffer),1,fp);
        if(i!=38) {fwrite(",",1,1,fp);ENTER;}}
    fwrite("};",2,1,fp); ENTER;ENTER;

    fwrite("unsigned char numberm[]={",25,1,fp); ENTER;
      for(i=28;i<39;i++) {
        sprintf(buffer,"0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X",dumpchar(2,i));
        fwrite(buffer,strlen(buffer),1,fp);
        if(i!=38) {fwrite(",",1,1,fp);ENTER;}}
    fwrite("};",2,1,fp); ENTER;ENTER;
    fprintf(fp,"void DisplayLetter(int x,int y, unsigned char *sprite1, unsigned char *sprite2,unsigned char *spritem){\n");
    fprintf(fp," Sprite8(x,y,8,spritem,GetPlane(0),SPRT_AND);Sprite8(x,y,8,spritem,GetPlane(1),SPRT_AND);\n");
    fprintf(fp," Sprite8(x,y,8,sprite1,GetPlane(0),SPRT_OR);Sprite8(x,y,8,sprite2,GetPlane(1),SPRT_OR);}\n");
    fprintf(fp,"void DisplaySpriteString(int x,int y,unsigned char *string){unsigned int i;\n");
    fprintf(fp," for(i=0;i<strlen(string);i++) {\n");
    fprintf(fp,"   if(string[i]>=65&&string[i]<=90) string[i]+=32;\n");
    fprintf(fp,"   if(string[i]>=97&&string[i]<=122){\n");
    fprintf(fp,"    DisplayLetter(x,y,letter1+(string[i]-97)*8,letter2+(string[i]-97)*8,letterm+(string[i]-97)*8);x+=9;}\n");
    fprintf(fp,"   if(string[i]==32) x+=6;\n");
    fprintf(fp,"   if(string[i]==58) { DisplayLetter(x,y,sprcolon1,sprcolon2,sprcolonm);x+=4; }\n");
    fprintf(fp,"   if(string[i]==45) { DisplayLetter(x,y,sprdash1,sprdash2,sprdashm);x+=9; }\n");
    fprintf(fp,"   if(string[i]>=47&&string[i]<=57){\n");
    fprintf(fp,"    DisplayLetter(x,y,number1+(string[i]-47)*8,number2+(string[i]-47)*8,numberm+(string[i]-47)*8);x+=9;}}}\n");
    fprintf(fp,"void text(int y,unsigned char *string){\n");
    fprintf(fp," unsigned int x=0,i;\n");
    fprintf(fp," for(i=0;i<strlen(string);i++) {\n");
    fprintf(fp,"  if(string[i]>=65&&string[i]<=90) string[i]+=32;\n");
    fprintf(fp,"  if(string[i]>=97&&string[i]<=122) x+=9;\n");
    fprintf(fp,"  if(string[i]==32) x+=6;\n");
    fprintf(fp,"  if(string[i]==58) x+=9;\n");
    fprintf(fp,"  if(string[i]==45) x+=9;\n");
    fprintf(fp,"  if(string[i]>=47&&string[i]<=57) x+=9;}");
    fprintf(fp," DisplaySpriteString(80-x/2,y,string);}");

		fclose(fp);}
}

void printerrmessage(void){
  printf("Font Maker v0.5 by PsiGoo (Michael Holt) 9/8/01\n");
  printf("psigoo@hotmail.com [http://calc.psigoo.com]\n\n");
  printf("MAKEFONT <infile> <outfile>\n");
  printf("        infile  - 8 bit bitmap image (no RLE compression)\n");
  printf("        outfile - output file\n\n");
  printf("Format: Each character must be 8x8.  Each character must be.\n");
  printf("        separated by 1 pixel.  Program will ignor everything past\n");
  printf("        8 pixels from the left border. Order: A-Z 0-9 : / -\n");
  printf("        Only these are supported currently.\n");
  printf("        Colors must be standard 16 color white,light gray,dark gray,and black.\n");
  printf("        Any other colors will be ignored and used to mask the sprite.\n\n");
  printf("C Syntax: void DisplaySpriteString(int x,int y,char *string) -- (x,y)\n");
  printf("          void text(int y,char *string)                      -- Centered Text");

}




int main(int argc, char *argv[]){
  BITMAP bmp;
  char openfile[20]={0},outputfile[20]={0};
  char i;
  if(argc!=3){printerrmessage();exit(1);}
  load_bmp(argv[1],&bmp);
  for(i=0;i<39;i++) doletter(i,&bmp);
  exportdata(argv[2]);

  printf("Font Maker v0.5 by PsiGoo (Michael Holt) 9/8/01\n");
  printf("psigoo@hotmail.com [http://calc.psigoo.com]\n\n");
  printf("Bitmap to C font conversion complete\n\n");
  printf("C Syntax: void DisplaySpriteString(int x,int y,char *string) -- (x,y)\n");
  printf("          void text(int y,char *string)                      -- Centered Text");
  free(bmp.data);

  return 0;
}
